#include<stdio.h>
#include <unistd.h>
		/* access() */
#include <stdlib.h>
	/* div() */
#include <sys/stat.h>
	/* mknod() */
#include <string.h>
#include "constantes.h"
#include "typedef.h"

extern char rep_base[];

int prepare_rep_stock(int date,char *rep_base_stock,char *type_rep_final)
{

div_t st_div;
int quot,an,mois,jour;
int bool_an,bool_mois,bool_jour;
char c_an[10],c_mois[10],c_jour[10];
char repertoire[255];
int retour;
FILE *fp;
char fich_erreur[100];

bool_an = FAUX;
bool_mois = FAUX;
bool_jour = FAUX;

/* decodage du repertoire final */
if (strstr(type_rep_final,"none") != NULL)
	{
	/* si il n'y a pas de rep final de prevu */
	return(0);
	};

if (strstr(type_rep_final,"###jour") != NULL)
	bool_jour = VRAI;

if (strstr(type_rep_final,"###mois") != NULL)
	bool_mois = VRAI;
else
	bool_jour = FAUX;

if (strstr(type_rep_final,"###annee") != NULL)
	bool_an = VRAI;
else
	{
	bool_mois = FAUX;
	bool_jour = FAUX;
	};


/* decomposition de la date en jour,mois annee */

st_div=div(date,100);
jour = st_div.rem;
quot = st_div.quot;
st_div=div(quot,100);
mois = st_div.rem;
an = st_div.quot;

fp = fopen("/dev/stdout","a");

if ( an < 0 || an > 3000)
	{
	fprintf(fp,"*** prepare_rep_stock: erreur decodage anne: %d\n",an);
	fclose(fp);
	return(-1);
	}
else if (an < 70 )
	an += 2000;
else if (an < 1900 )
	an += 1900;

if((mois < 1 || mois > 12) && bool_mois == VRAI)
	{
	fprintf(fp,"*** prepare_rep_stock: erreur decodage mois: %d\n",mois);
    fclose(fp);
	return(-1);
	};

if((jour < 1 || jour > 31) && bool_jour == VRAI)
	{
	fprintf(fp,"*** prepare_rep_stock: erreur decodage jour: %d\n",jour);
    fclose(fp);
	return(-1);
	};

strcpy(repertoire,rep_base_stock);
if( bool_an == VRAI )
	{
	if(access(repertoire,W_OK) == -1)
		/* retour = 0 si fichier est accessible en ecriture */
		/*         -1 si le fichier ne l'est pas */
		{
		fprintf(fp,"*** prepare_rep_stock: ecriture interdite pour: %s\n",
			repertoire);
	    fclose(fp);
		return(-1);
		};
	sprintf(c_an,"/%4.4d",an);
	strcat(repertoire,c_an);
	if(access(repertoire,F_OK) == -1)
		/* si le repertoire n'existe pas, on va le cree */
		/* retour = 0 si fichier existe */
		/*         -1 si le fichier n'existe pas*/
		if((retour=mkdir(repertoire,00755)) == -1)
			/* si on ne peut pas cree le repertoire */
			{
			fprintf(fp,"*** prepare_rep_stock: erreur creat rep: %s\n",
				repertoire);
		    fclose(fp);
			return(-1);
			};
	
	if( bool_mois == VRAI )
		{
		sprintf(c_mois,"/%2.2d",mois);
		strcat(repertoire,c_mois);
		if(access(repertoire,F_OK) == -1)
			/* si le repertoire n'existe pas, on va le cree */
			/* retour = 0 si fichier existe */
			/*         -1 si le fichier n'existe pas*/
			if(mkdir(repertoire,00755) == -1)
				/* si on ne peut pas cree le repertoire */
				{
				fprintf(fp,"*** prepare_rep_stock: erreur creat rep: %s\n",
					repertoire);
			    fclose(fp);
				return(-1);
				};

		if( bool_jour == VRAI )
			{
			sprintf(c_jour,"/%2.2d",jour);
			strcat(repertoire,c_jour);
			if(access(repertoire,F_OK) == -1)
				/* si le repertoire n'existe pas, on va le cree */
				/* retour = 0 si fichier existe */
				/*         -1 si le fichier n'existe pas*/
				if(mkdir(repertoire,00755) == -1)
					/* si on ne peut pas cree le repertoire */
					{
					fprintf(fp,"*** prepare_rep_stock: erreur creat rep: %s\n",
						repertoire);
 					fclose(fp);
					return(-1);
					};
			};

		};
			
	};

strcpy(rep_base_stock,repertoire);
fclose(fp);
return(0);

};

